<mat-horizontal-stepper #stepper class="full-width-table bles-container" (selectionChange)="onStepChanged($event)">

    <!-- change default 'edit' icon -->
    <ng-template matStepperIcon="edit">
        <mat-icon>done</mat-icon>
    </ng-template>
    
    <!-- step 1 -->
    <mat-step [stepControl]="zeroFormGroup">
        <form [formGroup]="zeroFormGroup" class="data-form" fxFlex="100%" fxLayout.xs="column" fxLayout="column" fxLayoutAlign="center left">
            <ng-template matStepLabel>General Information</ng-template>
            <h4>Experiment Blueprint</h4>
            <!-- <mat-form-field appearance="outline" color=primary class="data-full-width">
                <input matInput id="id" placeholder="Blueprint Id" required formControlName="bpIdCtrl">
            </mat-form-field> -->
            <mat-form-field appearance="outline" color=primary class="data-full-width">
                <input matInput id="name" placeholder="Blueprint Name" required formControlName="bpNameCtrl" (change)="onNameGiven($event);">
            </mat-form-field>
            <mat-form-field appearance="outline" color=primary class="data-full-width">
                <input matInput id="version" placeholder="Blueprint Version" required formControlName="bpVersionCtrl">
            </mat-form-field>
            <mat-form-field appearance="outline" color=primary class="data-full-width">
                <input matInput id="description" placeholder="Blueprint Description" formControlName="bpDescriptionCtrl">
            </mat-form-field>
            <!-- <mat-form-field appearance="outline" class="data-full-width">
              <mat-label>Deployment Type</mat-label>
              <mat-select formControlName="deploymentTypeCtrl" name="deployType" (selectionChange)="onDeploymentTypeSelected($event);">
                  <mat-option *ngFor="let deployType of deployTypes" [value]="deployType" #deployTypeSelected >
                      {{deployType}}
                  </mat-option>
              </mat-select>
          </mat-form-field> -->
            <div class="margin-top"></div>
            <p> Blueprint Name: {{expBlueprintName}}</p>
            <div class="margin-top">
                <button mat-raised-button matStepperNext color="primary" class="margin-all nextBtn"  [disabled]="zeroFormGroup.invalid" id="zeroFormGroupButton" >Next</button>
            </div>
        </form>
    </mat-step>

    <!-- step 2 -->
    <mat-step [stepControl]="firstFormGroup">
        <form [formGroup]="firstFormGroup" class="data-form" >

            <ng-template matStepLabel>VSB Selection</ng-template>

            <mat-form-field class="data-full-width">
                <input type="text"
                       placeholder="Select Blueprint"
                       aria-label="Number"
                       matInput
                       [formControl]="myControl"

                       [matAutocomplete]="auto"
                       style="cursor: pointer;">
                <mat-autocomplete #auto="matAutocomplete" (optionSelected)="onVsbSelected($event)" >
                  <mat-option *ngFor="let option of filteredOptions | async" [value]="option.viewValue" >
                    {{option.viewValue}}
                  </mat-option>
                </mat-autocomplete>
              </mat-form-field>

              <!--
                  (onSelectionChange)="onVsbSelected($event,option.value);"
                <div *ngIf="interSite && showSiteinterMode">
                    <div *ngFor="let blue of bluePrintsAssosiate" style="color: black;margin-bottom: 20px;">
                        <b>{{blue.associatedVsbId}}</b>
                        <mat-form-field appearance="outline" class="data-full-width">
                            <mat-label>Site</mat-label>
                            <mat-select  name="site" (selectionChange)="onSiteSelected($event,blue.associatedVsbId);" formControlName="selectVsbCtrl">
                                <div *ngFor="let site of sites">
                                <mat-option  *ngIf="blue.compatibleSite.includes(site.value)" [value]="site.value" >
                                    {{site.viewValue}}
                                </mat-option>
                            </div>
                            </mat-select>
                        </mat-form-field>
                    </div>
                </div>
                -->


            <div *ngIf="!interSite && showSiteNotinterMode">
                    <mat-form-field appearance="outline" class="data-full-width">
                        <mat-label>Site</mat-label>
                        <mat-select  name="site" (selectionChange)="onSiteSelected($event,null);" formControlName="selectVsbCtrl">
                            <div *ngFor="let site of sites">
                            <mat-option  *ngIf="bluePrintsAssosiate.includes(site.value)" [value]="site.value" >
                                {{site.viewValue}}
                            </mat-option>
                        </div>
                        </mat-select>
                    </mat-form-field>
            </div>


                <!--
              <div *ngFor="let blue of bluePrintsAssosiate">
                <mat-form-field appearance="outline" class="data-full-width">
                    <mat-label>bkue 1</mat-label>
                    <mat-select formControlName="selectSiteCtrl" name="site" (selectionChange)="onSiteSelected($event);">
                        <mat-option *ngFor="let site of sites" [value]="site.value" #siteSelected>
                            {{site.viewValue}}
                        </mat-option>
                    </mat-select>
                </mat-form-field>
              </div>

            <mat-form-field appearance="outline" class="data-full-width">
                <mat-label>Site</mat-label>
                <mat-select formControlName="selectSiteCtrl" name="site" (selectionChange)="onSiteSelected($event);">
                    <mat-option *ngFor="let site of sites" [value]="site.value" #siteSelected>
                        {{site.viewValue}}
                    </mat-option>
                </mat-select>
            </mat-form-field>
            <div class="margin-top"></div>
            <mat-form-field appearance="outline" class="data-full-width">
                <mat-label>VSB</mat-label>
                <mat-select formControlName="selectVsbCtrl" name="vsb" (selectionChange)="onVsbSelected($event);">
                    <mat-option *ngFor="let vsb of filterVsbsInSite()" [value]="vsb.value">
                        {{vsb.viewValue}}
                    </mat-option>
                </mat-select>
            </mat-form-field>
-->
            <div style="margin-top: 50px;">
            <p> Blueprint Name: {{expBlueprintName}}</p>
            <div *ngIf="interSite">
                <p> Selected Sites: </p>
                <div style="color: black;" *ngFor="let st of selectedSites">
                    <p style="margin-bottom: 3px;">{{st}}</p>
                 </div>
            </div>
            <div *ngIf="!interSite" style="color: black;">
                <p> Selected Site: {{selectedSite}}</p>

            </div>

            <p style="margin-top: 5px;"> Selected VSB: {{selectedVsb}}</p>
        </div>
            <div class="margin-top">
                <div *ngIf="!interSite">
                    <button mat-raised-button matStepperPrevious color="primary" class="margin-all backBtn">Back</button>

                    <button mat-raised-button matStepperNext color="primary" class="margin-all nextBtn" [disabled]="firstFormGroup.invalid">Next</button>
                </div>
                <div *ngIf="interSite">
                    <button mat-raised-button matStepperPrevious color="primary" class="margin-all backBtn">Back</button>

                    <button mat-raised-button matStepperNext color="primary" class="margin-all nextBtn" >Next</button>
                </div>
            </div>
        </form>
    </mat-step>


    <!-- step 6 -->
    <mat-step [stepControl]="fifthFormGroup">
        <form [formGroup]="fifthFormGroup" class="data-form" fxFlex="100%"  fxLayout="column" fxLayoutAlign="center left">
            <ng-template matStepLabel>Metrics & KPIs</ng-template>
            <table class="data-full-width" cellspacing="0" fxFlex="100%"  fxLayout="column" fxLayoutAlign="center left">
                <h4>Infrastructure metrics</h4>
                <div formArrayName="metric_items" *ngFor="let item of fifthFormGroup.get('metric_items')['controls']; let i=index">
                    <div [formGroupName]="i" fxFlex="100%"  fxLayout="column" fxLayoutAlign="center left">
                        <h5>Metric {{i + 1}}</h5>
                        <tr fxFlex="50%" fxLayout="row"  fxLayout.xs="column">
                            <td fxFlex="100%"  fxLayout.xs="column" fxLayout="column" fxLayoutAlign="center center">
                                <mat-form-field appearance="outline" color=primary class="data-full-width">
                                    <mat-label>Metric Type</mat-label>
                                    <mat-select formControlName="type" name="metricType" (selectionChange)="updateUnits($event, i);">
                                        <mat-option *ngFor="let type of metricTypes" [value]="type.value" #selectedMetric>
                                            {{type.viewValue}}
                                        </mat-option>
                                    </mat-select>
                                </mat-form-field>
                            </td>
                            <td fxFlex="100%"  fxLayout.xs="column" fxLayout="column" fxLayoutAlign="center center">
                              <mat-form-field appearance="outline" color=primary class="data-full-width">
                                <mat-label>Unit</mat-label>
                                <mat-select formControlName="unit" name="unitForm">
                                    <mat-option *ngFor="let unit of getFilteredMetricValues(i)" [value]="unit">{{unit}}</mat-option>
                                </mat-select>
                              </mat-form-field>
                          </td>
                            <td fxFlex="100%"  fxLayout.xs="column" fxLayout="column" fxLayoutAlign="center center">
                                <mat-form-field appearance="outline" color=primary class="data-full-width">
                                    <input matInput placeholder="Interval"  formControlName="interval">
                                </mat-form-field>
                            </td>


                        </tr>
                        <tr fxFlex="50%" fxLayout="row"  fxLayout.xs="column">

                            <td fxFlex="100%"  fxLayout.xs="column" fxLayout="column" fxLayoutAlign="center center">
                                <mat-form-field appearance="outline" color=primary class="data-full-width">
                                    <input matInput placeholder="Name" formControlName="name" (change)="onMetricGiven($event)">
                                </mat-form-field>
                            </td>
                            <td fxFlex="100%"  fxLayout.xs="column" fxLayout="column" fxLayoutAlign="center center">
                              <mat-form-field appearance="outline" color=primary class="data-full-width">
                                  <mat-label>Collection Type</mat-label>
                                  <mat-select formControlName="metricCollectionType" name="collectionType">
                                      <mat-option *ngFor="let type of collectionTypes" [value]="type">
                                          {{type}}
                                      </mat-option>
                                  </mat-select>
                              </mat-form-field>
                          </td>
                            <td fxFlex="100%"  fxLayout.xs="column" fxLayout="column" fxLayoutAlign="center center">
                              <mat-form-field appearance="outline" color=primary class="data-full-width">
                                  <mat-label>Graph Type</mat-label>
                                  <mat-select formControlName="metricGraphType" name="graphType">
                                      <mat-option *ngFor="let type of graphTypes" [value]="type">
                                          {{type}}
                                      </mat-option>
                                  </mat-select>

                                </mat-form-field>
                              </td>
                        </tr>
                            <tr>

                            <td fxFlex="33%"  fxLayout.xs="column" fxLayout="column" fxLayoutAlign="center center">
                                <mat-form-field appearance="outline" color=primary class="data-full-width">
                                    <input matInput placeholder="Metric Id" formControlName="metricId" >
                                </mat-form-field>
                            </td>
                            <td fxFlex="33%"  fxLayout.xs="column" fxLayout="column" fxLayoutAlign="center center">
                                    <mat-form-field appearance="outline" class="data-full-width">
                                        <mat-label>Target Site</mat-label>

                                        <mat-select formControlName="metricSelectSite" name="site" >
                                            <div *ngFor="let site of sites">
                                            <mat-option  [value]="site.value">
                                                {{site.viewValue}}
                                            </mat-option>
                                            </div>
                                        </mat-select>

                                    </mat-form-field>
                                </td>
                                <td fxFlex="33%"  fxLayout.xs="column" fxLayout="column" fxLayoutAlign="center center">

                                    <mat-form-field appearance="outline" class="data-full-width">
                                        <mat-label>componentIds</mat-label>

                                        <mat-select formControlName="componentIds" name="componentIds" multiple>
                                            <div *ngFor="let id of componentIds">
                                            <mat-option  [value]="id">
                                                {{id}}
                                            </mat-option>
                                            </div>
                                        </mat-select>

                                    </mat-form-field>
                                </td>
                                <td></td>
                            </tr>

                    </div>
                </div>
                
                <tr>
                    <td></td>
                    <td></td>
                    <td>
                        <div>
                            <button class="removeBtn" mat-fab (click)="removeMetricItem();" *ngIf="metric_items?.length > 1" color="primary"><mat-icon>remove</mat-icon></button>
                        </div>
                    </td>
                    <td>
                        <div>
                            <button class="addBtn" mat-fab (click)="addMetricItem();" color="primary"><mat-icon>add</mat-icon></button>
                        </div>
                    </td>
                </tr>


                <h4>KPIs</h4>
                <div formArrayName="kpi_items" *ngFor="let item of fifthFormGroup.get('kpi_items')?.controls; let i=index">
                    <div [formGroupName]="i" fxFlex="100%"  fxLayout="column" fxLayoutAlign="center left">
                        <h5>KPI {{i + 1}}</h5>
                        <tr fxFlex="50%" fxLayout="row"  fxLayout.xs="column">
                            <td fxFlex="100%" fxLayout.xs="column" fxLayout="column" fxLayoutAlign="center left">
                                <mat-form-field appearance="outline" color=primary class="data-full-width">
                                    <input matInput placeholder="Formula" (change)="validateFormula($event, i)" formControlName="formula" >

                                </mat-form-field>
                                <mat-error *ngIf="showErrorMessage(i);">Please enter a valid formula</mat-error>
                            </td>
                            <td fxFlex="100%"  fxLayout.xs="column" fxLayout="column" fxLayoutAlign="center left">
                              <mat-form-field appearance="outline" color=primary class="data-full-width">
                                  <input matInput placeholder="Unit" formControlName="unit">
                              </mat-form-field>
                            </td>
                            <td fxFlex="100%"  fxLayout.xs="column" fxLayout="column" fxLayoutAlign="center left">
                                <mat-form-field appearance="outline" color=primary class="data-full-width">
                                    <input matInput placeholder="Interval" formControlName="interval">
                                </mat-form-field>
                            </td>


                        </tr>
                        <tr fxFlex="50%" fxLayout="row"  fxLayout.xs="column">
                          <td fxFlex="100%"  fxLayout.xs="column" fxLayout="column" fxLayoutAlign="center left">
                            <mat-form-field appearance="outline" color=primary class="data-full-width">
                                <input matInput placeholder="KPI Id" formControlName="kpiId">
                            </mat-form-field>
                        </td>
                            <td fxFlex="100%"  fxLayout.xs="column" fxLayout="column" fxLayoutAlign="center left">
                                <mat-form-field appearance="outline" color=primary class="data-full-width">
                                    <input matInput placeholder="Name" formControlName="name" (change)="onKPIGiven($event)">
                                </mat-form-field>
                            </td>


                            <td fxFlex="100%"  fxLayout.xs="column" fxLayout="column" fxLayoutAlign="center left">
                              <mat-form-field appearance="outline" color=primary class="data-full-width">
                                <mat-label>Graph Type</mat-label>
                                <mat-select formControlName="graphType" name="kpiGraphType">
                                    <mat-option *ngFor="let type of graphTypes" [value]="type">
                                        {{type}}
                                    </mat-option>
                                </mat-select>

                              </mat-form-field>

                            </td>
                        </tr>
                        <tr fxFlex="50%" fxLayout="row"  fxLayout.xs="column">

                          <td fxFlex="100%"  fxLayout.xs="column" fxLayout="column" fxLayoutAlign="center left">
                            <mat-form-field appearance="outline" color=primary class="data-full-width">
                              <textarea matInput placeholder="Metric Ids (comma separated)"  formControlName="metricIds" style="color: black;"></textarea>
                              </mat-form-field>
                        </td>

                        </tr>
                    </div>
                </div>
                
                
                <tr>
                    <td></td>
                    <td></td>
                    <td>
                        <div>
                            <button class="removeBtn" mat-fab (click)="removeKPIItem();" *ngIf="kpi_items?.length > 1" color="primary"><mat-icon>remove</mat-icon></button>
                        </div>
                    </td>
                    <td>
                        <div>
                            <button class="addBtn" mat-fab (click)="addKPIItem();" color="primary"><mat-icon>add</mat-icon></button>
                        </div>
                    </td>
                </tr>
            </table>


            <div class="margin-top"></div>
            <p> Blueprint Name: {{expBlueprintName}}</p>
            <div *ngIf="interSite">
                <p> Selected Sites: </p>
                <div style="color: black;" *ngFor="let st of selectedSites">
                    <p style="margin-bottom: 3px;">{{st}}</p>
                 </div>
            </div>
            <div *ngIf="!interSite" style="color: black;">
                <p> Selected Site: {{selectedSite}}</p>
            </div>
            <p> Selected VSB: {{selectedVsb}}</p>
            <!-- <p> Selected CBs: {{selectedCbs.join(', ')}}</p> -->
            <!-- <p> Uploaded NSD: {{uploadedNsdName}}</p> -->
            <!-- <p> Parameters: {{parameterNames.join(', ')}}</p> -->
            <p> Metrics: {{metricNames.join(', ')}}</p>
            <p> KPIs: {{kpiNames.join(', ')}}</p>
            <div class="margin-top">
                <!-- <button mat-raised-button id="staticTypeBack" (click) = "goToStepIndex(2);" color="primary" class="margin-all">Back</button> -->
                <button mat-raised-button id="onDemandTypeBack" matStepperPrevious color="primary" class="margin-all backBtn">Back</button>
                <button mat-raised-button matStepperNext color="primary" class="margin-all nextBtn" [disabled]="!isRegularExpression">Next</button>
            </div>
        </form>
    </mat-step>

    <!-- step 7 -->
    <mat-step [stepControl]="sixthFormGroup">
        <form [formGroup]="sixthFormGroup" class="rules-form">
            <ng-template matStepLabel>Test Cases</ng-template>
            <mat-form-field class="data-full-width" 
            >
                <input type="text"
                       placeholder="Select Test Case"
            required formControlName="selectTcbsCtrl"
                       matInput
                       [formControl]="myControltc"
                       [matAutocomplete]="autoTc"
                       style="cursor: pointer;">
                <mat-autocomplete #autoTc="matAutocomplete" (optionSelected)="onTcbSelected($event)" >
                  <mat-option *ngFor="let option of TcfilteredOptions | async" [value]="option.viewValue" >
                    {{option.viewValue}}
                  </mat-option>
                </mat-autocomplete>
              </mat-form-field>

            <!-- <mat-selection-list class="flex-column">
                <mat-form-field appearance="outline" color=primary class="data-full-width">
                <input matInput id="name" placeholder="Blueprint Name" required formControlName="bpNameCtrl" (change)="onNameGiven($event);">
            </mat-form-field>
                <mat-checkbox *ngFor="let tcb of tcbs; let i=index;" formControlName="selectTcbsCtrl" (change)="onSelectedTcbs($event, tcb.value)" style="color: black;">
                  {{tcb.viewValue}}
                </mat-checkbox>

              </mat-selection-list> -->
            <div class="margin-top"></div>
            <p> Blueprint Name: {{expBlueprintName}}</p>
            <p> Selected Site: {{selectedSite}}</p>
            <p> Selected VSB: {{selectedVsb}}</p>
            <!-- <p> Selected CBs: {{selectedCbs.join(', ')}}</p> -->
            <!-- <p> Uploaded NSD: {{uploadedNsdName}}</p> -->
            <p> Metrics: {{metricNames.join(', ')}}</p>
            <p> KPIs: {{kpiNames.join(', ')}}</p>
            <p> Selected TCB: {{selectedTcb}}</p>
            <!-- <p> Selected TCs: {{selectedTcbs.join(', ')}}</p> -->
            <div class="margin-top">
                <button mat-raised-button matStepperPrevious color="primary" class="margin-all backBtn">Back</button>
                <button mat-raised-button (click)="stepper.reset()" color="warn" class="margin-all resetBtn">Reset</button>
               <!--<button mat-raised-button color="accent" class="margin-all"  (click)="createOnBoardExpBlueprintRequest(nsdFiles.files);">Submit</button>-->
               
               <div *ngIf="tcbs.length > 0">
                <button mat-raised-button color="black" class="margin-all submitBtn" [disabled]="sixthFormGroup.invalid"  (click)="createOnBoardExpBlueprintRequest(null);">Submit</button>
               </div>
                <div *ngIf="tcbs.length <= 0">
               <button mat-raised-button color="black" class="margin-all submitBtn" [disabled]="true"  (click)="createOnBoardExpBlueprintRequest(null);">Submit</button>
               </div>
            </div>
        </form>
    </mat-step>
</mat-horizontal-stepper>
